import { QueryNodeOptions } from "@taze-editor/taze-core";
export interface NodeIdPlugin extends QueryNodeOptions {
    /**
     * Node key to store the id.
     * @default 'id'
     */
    idKey?: string;
    /**
     * ID factory, e.g. `uuid`
     * @default () => Date.now().toString()
     */
    idCreator?: Function;
    /**
     * Filter `Text` nodes.
     * @default true
     */
    filterText?: boolean;
    /**
     * Reuse ids on undo/redo and copy/pasting if not existing in the document.
     * This is disabled by default to avoid duplicate ids across documents.
     * @default false
     */
    reuseId?: boolean;
}
export declare const KEY_NODE_ID = "nodeId";
/**
 * @see {@link withNodeId}
 */
export declare const createNodeIdPlugin: <OP = NodeIdPlugin, OV extends import("@taze-editor/taze-core").Value = import("@taze-editor/taze-core").Value, OE extends import("@taze-editor/taze-core").TazeEditor<OV> = import("@taze-editor/taze-core").TazeEditor<OV>>(override?: Partial<import("@taze-editor/taze-core").TazePlugin<import("@taze-editor/taze-core").NoInfer<OP>, OV, OE, any>> | undefined, overrideByKey?: import("@taze-editor/taze-core").OverrideByKey<OV, OE> | undefined) => import("@taze-editor/taze-core").TazePlugin<import("@taze-editor/taze-core").NoInfer<OP>, OV, OE, any>;
//# sourceMappingURL=createNodeIdPlugin.d.ts.map